package org.apache.bcel.classfile;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import java.io.DataInput;
import java.io.DataOutputStream;
import java.io.IOException;
import org.apache.bcel.classfile.Attribute;
import org.apache.bcel.classfile.Constant;
import org.apache.bcel.classfile.ConstantDouble;
import org.apache.bcel.classfile.ConstantFloat;
import org.apache.bcel.classfile.ConstantInteger;
import org.apache.bcel.classfile.ConstantLong;
import org.apache.bcel.classfile.ConstantPool;
import org.apache.bcel.classfile.ConstantString;
import org.apache.bcel.classfile.ConstantUtf8;
import org.apache.bcel.classfile.Utility;
import org.apache.bcel.classfile.Visitor;

public final class ConstantValue extends Attribute {
  private int constantValueIndex;
  
  public ConstantValue(org.apache.bcel.classfile.ConstantValue c) {
    this(c.getNameIndex(), c.getLength(), c.getConstantValueIndex(), c.getConstantPool());
  }
  
  ConstantValue(int nameIndex, int length, DataInput input, ConstantPool constantPool) throws IOException {
    this(nameIndex, length, input.readUnsignedShort(), constantPool);
  }
  
  public ConstantValue(int nameIndex, int length, int constantValueIndex, ConstantPool constantPool) {
    super((byte)1, nameIndex, length, constantPool);
    this.constantValueIndex = constantValueIndex;
  }
  
  public void accept(Visitor v) {
    v.visitConstantValue(this);
  }
  
  public Attribute copy(ConstantPool constantPool) {
    org.apache.bcel.classfile.ConstantValue c = (org.apache.bcel.classfile.ConstantValue)clone();
    c.setConstantPool(constantPool);
    return c;
  }
  
  public void dump(DataOutputStream file) throws IOException {
    super.dump(file);
    file.writeShort(this.constantValueIndex);
  }
  
  public int getConstantValueIndex() {
    return this.constantValueIndex;
  }
  
  public void setConstantValueIndex(int constantValueIndex) {
    this.constantValueIndex = constantValueIndex;
  }
  
  public String toString() {
    String buf;
    int i;
    Constant c = getConstantPool().getConstant(this.constantValueIndex);
    switch (c.getTag()) {
      case 5:
        buf = String.valueOf(((ConstantLong)c).getBytes());
        return buf;
      case 4:
        buf = String.valueOf(((ConstantFloat)c).getBytes());
        return buf;
      case 6:
        buf = String.valueOf(((ConstantDouble)c).getBytes());
        return buf;
      case 3:
        buf = String.valueOf(((ConstantInteger)c).getBytes());
        return buf;
      case 8:
        i = ((ConstantString)c).getStringIndex();
        c = getConstantPool().getConstantUtf8(i);
        buf = "\"" + Utility.convertString(((ConstantUtf8)c).getBytes()) + "\"";
        return buf;
    } 
    throw new IllegalStateException("Type of ConstValue invalid: " + c);
  }
}
